﻿var stepsCount = 0;
var steps = [];
var reviewersMap = new Map();

$(document).ready(function () {
    loadDataContentApprovalDefinitions();
});

function loadDataContentApprovalDefinitions() {
    $.ajax({
        url: "/ContentApprovalWorkFlowPlugin/ListContentApprovalDefinitions",
        type: "GET",
        contentType: "application/json;charset=utf-8",
        dataType: "json",
        success: function (result) {
            var html = '';
            $.each(result, function (key, item) {

                if (item.Name !== "None") {
                    var checked = item.UserInitialized ? "checked" : "";
                    var userToInitialize = item.UserToInitialize !== null ? item.UserToInitialize : "";
                    var userComment = item.UserComment !== null ? item.UserComment : "";

                    html += '<tr>';
                    html += '<td>' + item.Name + '</td>';
                    //html += '<td><input type="checkbox" disabled readonly ' + checked + '></input></td>';
                    //html += '<td>' + userToInitialize + '</td>';
                    //html += '<td>' + userComment + '</td>';
                    html += '<td><a href="#" onclick="return getApprovalDefinitionByID(\'' + item.Identification + '\')">Edit</a> | <a href="#" onclick="DeleteApprovalDefinition(\'' + item.Identification + '\')">Delete</a></td>';
                    html += '</tr>';
                }
            });

            $('#approvalDefinitionsBody').html(html);
        },

        error: function (errorMessage) {
            if (errorMessage) {
                console.log("ListContentApprovalDefinitions: " + errorMessage.responseText);
            }
        }
    });
}

function addStepToAccordion() {
    stepsCount += 1;
    steps.push(stepsCount);

    let step = '<div id="Step' + stepsCount + '">' +
        '<h3>Step</h3>' +
        '<div>' +
        '<div class="form-group">' +
        '<label for="Name' + stepsCount + '">Content Approval Step Name</label>' +
        '<input type="text" class="form-control" id="Name' + stepsCount + '" name="Name' + stepsCount + '" placeholder="Step Name" />' +
        '</div>' +
        '<div class="form-group">' +
        '<div id="steps-reviewers' + stepsCount + '">' +
        '</div>' +
        '<input id="btnAddReviewer' + stepsCount + '" type="button" onclick="addReviewerToStep(' + stepsCount + ')" value="Add Reviewer" />&nbsp;&nbsp;' +
        '<input id="btnDeleteStep' + stepsCount + '" type="button" onclick="deleteStepFromAccordion(' + stepsCount + ')" value="Delete Step" />' +
        '</div>' +
        '</div>' +
        '</div>';

    $('#steps-accordion').append(step);
}

function deleteStepFromAccordion(stepId) {
    var index = steps.indexOf(stepId);
    if (index > -1) {
        steps.splice(index, 1);
    }

    $('#Step' + stepId).remove();
    if (reviewersMap.has(stepId)) {
        reviewersMap.delete(stepId);
    }
    stepsCount -= 1;
    steps.push(stepsCount);
}

function addReviewerToStep(stepId) {
    if (!reviewersMap.has(stepId)) {
        reviewersMap.set(stepId, [1]);
    } else {
        let array = reviewersMap.get(stepId);

        let newValue = array[array.length - 1] === undefined ? 1 : array[array.length - 1] + 1;
        array.push(newValue);

        reviewersMap.set(stepId, array);
    }

    let lastValue = reviewersMap.get(stepId)[reviewersMap.get(stepId).length - 1];
    let reviewer = '<div id="Reviewer' + stepId + "_" + lastValue + '">' +
        '<h2>Reviewer</h2>' +
        '<div>' +
        '<div class="form-group">' +
        '<label for="RolOrUserName' + stepId + "_" + lastValue + '">Content Approval Reviewer</label>' +
        '<input type="text" class="form-control" id="RolOrUserName' + stepId + "_" + lastValue + '" name="RolOrUserName' + stepId + "_" + lastValue + '" placeholder="Rol or User Name" />' +
        '</div>' +
        '<div class="form-group">' +
        '<label for="ReviewerType' + stepId + "_" + lastValue + '">Reviewer Type &nbsp;&nbsp;</label>' +
        '<select id="ReviewerType' + stepId + "_" + lastValue + '" name="ReviewerType' + stepId + "_" + lastValue + '">' +
        '<option value="ROLE">Role</option>' +
        '<option value="USER">User</option>' +
        '</select>' +
        '</div>' +
        '<div class="form-group">' +
        '<input id="btnDeleteReviewer' + stepsCount + '" type="button" onclick="deleteReviewerFromStep(' + stepId + ',' + lastValue + ')" value="Delete Reviewer" />&nbsp;&nbsp;' +
        '</div>' +
        '</div>' +
        '</div>';

    $('#steps-reviewers' + stepId).append(reviewer);
}

function deleteReviewerFromStep(stepId, reviewerId) {
    var array = reviewersMap.get(stepId);
    var index = array.indexOf(reviewerId);
    if (index > -1) {
        array.splice(index, 1);
    }

    reviewersMap.set(stepId, array);
    $('#Reviewer' + stepId + "_" + reviewerId).remove();
}

function clearTextBoxApprovalDefinitions() {
    stepsCount = 0;
    steps = [];
    reviewersMap = new Map();
    $('#Id').val("");
    $('#Name').val("");
    $('#UserToInitialize').val("");
    $('#UserComment').val("");
    $('#UserInitialized').attr('checked', false);
    $('#UserInitialized').prop('checked', false);
    $("#UserToInitialize").prop('disabled', true);
    $("#UserComment").prop('disabled', true);
    $('#UserToInitialize').css('border-color', 'lightgrey');
    $('#UserComment').css('border-color', 'lightgrey');
    $('#steps-accordion').empty();
    $('#btnUpdate').hide();
    $('#btnAdd').show();

    $('#UserInitialized').change(function () {
        if ($(this).is(":checked")) {
            $("#UserToInitialize").prop('disabled', false);
            $("#UserComment").prop('disabled', false);
        } else {
            $("#UserToInitialize").prop('disabled', true);
            $("#UserComment").prop('disabled', true);
            $('#UserToInitialize').val("");
            $('#UserComment').val("");
        }
    });
}

function getApprovalDefinitionByID(id) {
    clearTextBoxApprovalDefinitions();
    $('#Id').css('border-color', 'lightgrey');
    $('#Name').css('border-color', 'lightgrey');

    $.ajax({
        url: "/ContentApprovalWorkFlowPlugin/GetApprovalDefinitionById",
        data: "id=" + id + "",
        type: "POST",
        dataType: "json",

        success: function (result) {
            $('#Id').val(result.Identification);
            $('#Name').val(result.Name);
            $('#UserToInitialize').val(result.UserToInitialize === null || result.UserToInitialize === undefined ? "" : result.UserToInitialize);
            $('#UserComment').val(result.UserComment === null || result.UserComment === undefined ? "" : result.UserComment);

            $('#UserInitialized').change(function () {
                if ($(this).is(":checked")) {
                    $("#UserToInitialize").prop('disabled', false);
                    $("#UserComment").prop('disabled', false);
                } else {
                    $("#UserToInitialize").prop('disabled', true);
                    $("#UserComment").prop('disabled', true);
                    $('#UserToInitialize').val("");
                    $('#UserComment').val("");
                }
            });

            $('#UserInitialized').attr('checked', result.UserInitialized);
            $('#UserInitialized').prop('checked', result.UserInitialized);

            if (!result.UserInitialized) {
                $("#UserToInitialize").prop('disabled', true);
                $("#UserComment").prop('disabled', true);
                $('#UserToInitialize').val("");
                $('#UserComment').val("");
            } else {
                $("#UserToInitialize").prop('disabled', false);
                $("#UserComment").prop('disabled', false);
            }

            loadStepsAndReviewersInformationFromResponse(result);
            $('#approvalDefinitionModal').modal('show');
            $('#btnUpdate').show();
            $('#btnAdd').hide();
        },

        error: function (errorMessage) {
            console.log("GetApprovalDefinitionById: " + errorMessage.responseText);
        }
    });

    return false;
}

function loadStepsAndReviewersInformationFromResponse(result) {
    var steps = result.ApprovalDefinitionStepsData;
    for (var i = 0; i < steps.length; i++) {
        addStepToAccordion();
        $('#Name' + (i + 1)).val(steps[i].Name);

        var reviewers = steps[i].ApprovalDefinitionReviewersData;
        for (var j = 0; j < reviewers.length; j++) {
            addReviewerToStep(i + 1);
            $('#RolOrUserName' + (i + 1) + '_' + (j + 1)).val(reviewers[j].UserOrRolName);
            $('#ReviewerType' + (i + 1) + '_' + (j + 1)).val(reviewers[j].ReviewerType);
        }
    }
}

function AddApprovalDefinition() {
    var res = validateApprovalDefinition();
    if (res === false) {
        return false;
    }

    var data = $('#frmApprovalDefinition').serialize();

    $.ajax({
        url: "/ContentApprovalWorkFlowPlugin/AddApprovalDefinition",
        data: data,
        type: "POST",
        dataType: "json",

        success: function (result) {
            $('#approvalDefinitionModal').modal('hide');
            location.reload();
        },

        error: function (errorMessage) {
            console.log("AddApprovalDefinition: " + errorMessage.responseText);
        }
    });
}

function UpdateApprovalDefinition() {
    var res = validateApprovalDefinition();
    if (res === false) {
        return false;
    }

    var data = $('#frmApprovalDefinition').serialize();

    $.ajax({
        url: "/ContentApprovalWorkFlowPlugin/UpdateApprovalDefinition",
        data: data,
        type: "POST",
        dataType: "json",

        success: function (result) {
            loadDataContentApprovalDefinitions();
            $('#approvalDefinitionModal').modal('hide');
            location.reload();
        },

        error: function (errorMessage) {
            console.log("UpdateApprovalDefinition: " + errorMessage.responseText);
        }
    });
}

function DeleteApprovalDefinition(id) {
    var ans = confirm("Are you sure you want to delete this Record?");
    if (ans) {
        $.ajax({
            url: "/ContentApprovalWorkFlowPlugin/DeleteApprovalDefinition",
            data: "id=" + id + "",
            type: "POST",
            dataType: "json",
            success: function (result) {
                if (result.substr(0, 6) === "Failed") {
                    console.log("DeleteApprovalDefinition (success): " + result);
                } else {
                    loadDataContentApprovalDefinitions();
                    location.reload();
                }
            },
            error: function (errorMessage) {
                console.log("DeleteApprovalDefinition: " + errorMessage.responseText);
            }
        });
    }
}

function validateApprovalDefinition() {
    var pattern = /^(http(s)?:\/\/)?(www\.)?[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}(:[0-9]{1,5})?(\/.*)?$/;

    var isValid = true;
    if ($('#Name').val().trim() === "") {
        $('#Name').css('border-color', 'Red');
        isValid = false;
    }
    else {
        $('#Name').css('border-color', 'lightgrey');
    }

    if ($('#UserInitialized').is(":checked")) {
        if ($('#UserToInitialize').val().trim() === "") {
            $('#UserToInitialize').css('border-color', 'Red');
            isValid = false;
        }
        else {
            $('#UserToInitialize').css('border-color', 'lightgrey');
        }

        if ($('#UserComment').val().trim() === "") {
            $('#UserComment').css('border-color', 'Red');
            isValid = false;
        }
        else {
            $('#UserComment').css('border-color', 'lightgrey');
        }
    }
    
    for (var i = 1; i <= stepsCount; i++) {
        if ($('#Name' + i).val().trim() === "") {
            $('#Name' + i).css('border-color', 'Red');
            isValid = false;
            break;
        }
        else {
            $('#Name' + i).css('border-color', 'lightgrey');
        }

        for (var j = 1; j <= reviewersMap.get(i); j++) {
            if ($('#RolOrUserName' + i + "_" + j).val().trim() === "") {
                $('#RolOrUserName' + i + "_" + j).css('border-color', 'Red');
                isValid = false;
                break;
            }
            else {
                $('#RolOrUserName' + i + "_" + j).css('border-color', 'lightgrey');
            }
        }
    }

    return isValid;
}